## qbs 3.1.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

if(CMAKE_VERSION VERSION_GREATER_EQUAL "3.15")
    cmake_policy(VERSION 3.15)
endif()

## Add paths to check for cmake modules:
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

include(FeatureSummary)
include(QbsBuildConfig)
include(QbsDocumentation)

file(STRINGS VERSION QBS_VERSION)
project(Qbs VERSION ${QBS_VERSION})

# Force C++ standard, do not fall back, do not use compiler extensions
set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_POSITION_INDEPENDENT_CODE ON)

# Set up Qt stuff:
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)

find_package(QT NAMES Qt6 Qt5 COMPONENTS Core REQUIRED)

if(WITH_TESTS)
    enable_testing()
    set(QT_TEST_COMPONENT Test)
    set(IMPLICIT_DEPENDS Qt${QT_VERSION_MAJOR}::Test)
endif()

find_package(Qt${QT_VERSION_MAJOR}
    COMPONENTS Concurrent Core Gui Network Widgets Xml ${QT_TEST_COMPONENT}
    REQUIRED
    )

find_package(Qt${QT_VERSION_MAJOR} OPTIONAL_COMPONENTS Script QUIET)

if (Qt6_FOUND)
    find_package(Qt${QT_VERSION_MAJOR} COMPONENTS Core5Compat REQUIRED)
    if(NOT TARGET Qt6Core5Compat)
        if(CMAKE_VERSION VERSION_LESS 3.18)
            set_property(TARGET Qt6::Core5Compat PROPERTY IMPORTED_GLOBAL TRUE) # hack for CMake < 3.18
        endif()
        add_library(Qt6Core5Compat ALIAS Qt6::Core5Compat)
    endif()
else()
  if(NOT TARGET Qt6Core5Compat)
    add_library(Qt6Core5Compat INTERFACE)
  endif()
  find_package(Qt${QT_VERSION_MAJOR} OPTIONAL_COMPONENTS DocTools)
endif()

if (QBS_INSTALL_HTML_DOCS OR QBS_INSTALL_QCH_DOCS)
    find_package(Python3 COMPONENTS Interpreter)
    if (Qt6_FOUND)
        find_package(Qt${QT_VERSION_MAJOR} COMPONENTS Tools REQUIRED)
    else()
        find_package(Qt${QT_VERSION_MAJOR} COMPONENTS Help REQUIRED)
    endif()
endif()

add_definitions(-DQT_NO_QSNPRINTF -D_UCRT_NOISY_NAN)

add_subdirectory(src)
add_subdirectory(doc)
add_subdirectory(share)
if(WITH_TESTS)
    add_subdirectory(tests)
endif()

=== doc/CMakeLists.txt ===
set(_DOC_SOURCES
    ../README.md
    ../CONTRIBUTING.md
    classic.css
    external-resources.qdoc
    fixnavi.pl
    howtos.qdoc
    qbs.qdoc
    qbs-online.qdocconf
    config/style/qt5-sidebar.html
    )

file(GLOB_RECURSE _DOC_APPENDIX_SOURCES "${CMAKE_CURRENT_SOURCE_DIR}/appendix/*")
file(GLOB_RECURSE _DOC_REFERENCE_SOURCES "${CMAKE_CURRENT_SOURCE_DIR}/reference/*")
file(GLOB_RECURSE _DOC_TEMPLATES_SOURCES "${CMAKE_CURRENT_SOURCE_DIR}/templates/*")
file(GLOB_RECURSE _DOC_IMAGES_SOURCES "${CMAKE_CURRENT_SOURCE_DIR}/images/*")
file(GLOB_RECURSE _DOC_TARGETS_SOURCES "${CMAKE_CURRENT_SOURCE_DIR}/targets/*")

add_qbs_documentation(
    "qbs.qdocconf"
    SOURCES
        ${_DOC_SOURCES}
        ${_DOC_APPENDIX_SOURCES}
        ${_DOC_REFERENCE_SOURCES}
        ${_DOC_TEMPLATES_SOURCES}
        ${_DOC_IMAGES_SOURCES}
        ${_DOC_TARGETS_SOURCES}
    )

add_subdirectory(man)

=== src/app/CMakeLists.txt ===
add_subdirectory(config)
add_subdirectory(config-ui)
add_subdirectory(qbs)
add_subdirectory(qbs-create-project)
add_subdirectory(qbs-setup-android)
add_subdirectory(qbs-setup-qt)
add_subdirectory(qbs-setup-toolchains)
add_subdirectory(shared)

=== src/libexec/CMakeLists.txt ===
add_subdirectory(qbs_processlauncher)

=== src/plugins/CMakeLists.txt ===
add_subdirectory(generator)
add_subdirectory(scanner)

=== src/app/qbs-setup-android/CMakeLists.txt ===
set(SOURCES
    android-setup.cpp
    android-setup.h
    commandlineparser.cpp
    commandlineparser.h
    main.cpp
    )

add_qbs_app(qbs-setup-android
    DEPENDS qbscore qbsconsolelogger
    SOURCES ${SOURCES}
    )

=== src/lib/corelib/CMakeLists.txt ===
set(QBS_HEADERS qbs.h)

set(FILE_UPDATE_SOURCES
    changeset.cpp
    changeset.h
    projectfileupdater.cpp
    projectfileupdater.h
    qmljsrewriter.cpp
    qmljsrewriter.h
    )
list_transform_prepend(FILE_UPDATE_SOURCES api/)

set(API_SOURCES
    internaljobs.cpp
    internaljobs.h
    jobs.cpp
    languageinfo.cpp
    project.cpp
    project_p.h
    projectdata.cpp
    projectdata_p.h
    propertymap_p.h
    rulecommand.cpp
    rulecommand_p.h
    runenvironment.cpp
    transformerdata.cpp
    transformerdata_p.h
    )
list_transform_prepend(API_SOURCES api/)

set(API_HEADERS
    jobs.h
    languageinfo.h
    project.h
    projectdata.h
    rulecommand.h
    runenvironment.h
    transformerdata.h
    )
list_transform_prepend(API_HEADERS api/)

set(BUILD_GRAPH_SOURCES
    abstractcommandexecutor.cpp
    abstractcommandexecutor.h
    artifact.cpp
    artifact.h
    artifactcleaner.cpp
    artifactcleaner.h
    artifactsscriptvalue.cpp
    artifactsscriptvalue.h
    artifactvisitor.cpp
    artifactvisitor.h
    buildgraph.cpp
    buildgraph.h
    buildgraphnode.cpp
    buildgraphnode.h
    buildgraphloader.cpp
    buildgraphloader.h
    buildgraphvisitor.h
    cppmodulesscanner.cpp
    cppmodulesscanner.h
    cycledetector.cpp
    cycledetector.h
    dependencyparametersscriptvalue.cpp
    dependencyparametersscriptvalue.h
    depscanner.cpp
    depscanner.h
    emptydirectoriesremover.cpp
    emptydirectoriesremover.h
    environmentscriptrunner.cpp
    environmentscriptrunner.h
    executor.cpp
    executor.h
    executorjob.cpp
    executorjob.h
    filedependency.cpp
    filedependency.h
    inputartifactscanner.cpp
    inputartifactscanner.h
    jscommandexecutor.cpp
    jscommandexecutor.h
    nodeset.cpp
    nodeset.h
    nodetreedumper.cpp
    nodetreedumper.h
    processcommandexecutor.cpp
    processcommandexecutor.h
    productbuilddata.cpp
    productbuilddata.h
    productinstaller.cpp
    productinstaller.h
    projectbuilddata.cpp
    projectbuilddata.h
    qtmocscanner.cpp
    qtmocscanner.h
    rawscanneddependency.cpp
    rawscanneddependency.h
    rawscanresults.cpp
    rawscanresults.h
    requestedartifacts.cpp
    requestedartifacts.h
    requesteddependencies.cpp
    requesteddependencies.h
    rescuableartifactdata.h
    rulecommands.cpp
    rulecommands.h
    rulegraph.cpp
    rulegraph.h
    rulenode.cpp
    rulenode.h
    rulesapplicator.cpp
    rulesapplicator.h
    rulesevaluationcontext.cpp
    rulesevaluationcontext.h
    timestampsupdater.cpp
    timestampsupdater.h
    transformer.cpp
    transformer.h
    transformerchangetracking.cpp
    transformerchangetracking.h
    )
list_transform_prepend(BUILD_GRAPH_SOURCES buildgraph/)

set(BUILD_GRAPH_HEADERS buildgraph/forward_decls.h)

set(GENERATORS_SOURCES
    generatableprojectiterator.cpp
    generatableprojectiterator.h
    generator.cpp
    generatordata.cpp
    generatorutils.cpp
    generatorutils.h
    generatorversioninfo.cpp
    generatorversioninfo.h
    igeneratableprojectvisitor.h
    ixmlnodevisitor.h
    xmlproject.cpp
    xmlproject.h
    xmlprojectwriter.cpp
    xmlprojectwriter.h
    xmlproperty.cpp
    xmlproperty.h
    xmlpropertygroup.cpp
    xmlpropertygroup.h
    xmlworkspace.cpp
    xmlworkspace.h
    xmlworkspacewriter.cpp
    xmlworkspacewriter.h
    )
list_transform_prepend(GENERATORS_SOURCES generators/)

set(GENERATORS_HEADERS generators/generator.h generators/generatordata.h)

set(JS_EXTENSIONS_SOURCES
    environmentextension.cpp
    file.cpp
    fileinfoextension.cpp
    host.cpp
    jsextensions.cpp
    jsextensions.h
    moduleproperties.cpp
    moduleproperties.h
    pkgconfigjs.cpp
    pkgconfigjs.h
    process.cpp
    temporarydir.cpp
    textfile.cpp
    binaryfile.cpp
    utilitiesextension.cpp
    domxml.cpp
    )
list_transform_prepend(JS_EXTENSIONS_SOURCES jsextensions/)

if(APPLE)
    set(JS_EXTENSIONS_MACOS_SOURCES
        propertylist_darwin.mm
        propertylistutils.h
        propertylistutils.mm
        )
else()
    set(JS_EXTENSIONS_MACOS_SOURCES propertylist.cpp)
endif()
list_transform_prepend(JS_EXTENSIONS_MACOS_SOURCES jsextensions/)

set(LANGUAGE_SOURCES
    artifactproperties.cpp
    artifactproperties.h
    asttools.cpp
    asttools.h
    builtindeclarations.cpp
    builtindeclarations.h
    deprecationinfo.h
    evaluator.cpp
    evaluator.h
    filecontext.cpp
    filecontext.h
    filecontextbase.cpp
    filecontextbase.h
    filetags.cpp
    filetags.h
    identifiersearch.cpp
    identifiersearch.h
    item.cpp
    item.h
    itemdeclaration.cpp
    itemdeclaration.h
    itemobserver.h
    itempool.cpp
    itempool.h
    itemtype.h
    jsimports.h
    language.cpp
    language.h
    moduleproviderinfo.h
    preparescriptobserver.cpp
    preparescriptobserver.h
    property.cpp
    property.h
    propertydeclaration.cpp
    propertydeclaration.h
    propertymapinternal.cpp
    propertymapinternal.h
    qualifiedid.cpp
    qualifiedid.h
    resolvedfilecontext.cpp
    resolvedfilecontext.h
    scriptengine.cpp
    scriptengine.h
    scriptimporter.cpp
    scriptimporter.h
    scriptpropertyobserver.cpp
    scriptpropertyobserver.h
    value.cpp
    value.h
    )
list_transform_prepend(LANGUAGE_SOURCES language/)

set(LANGUAGE_HEADERS language/forward_decls.h)

set(LOADER_SOURCES
    astimportshandler.cpp
    astimportshandler.h
    astpropertiesitemhandler.cpp
    astpropertiesitemhandler.h
    dependenciesresolver.cpp
    dependenciesresolver.h
    groupshandler.cpp
    groupshandler.h
    itemreader.cpp
    itemreader.h
    itemreaderastvisitor.cpp
    itemreaderastvisitor.h
    itemreadervisitorstate.cpp
    itemreadervisitorstate.h
    loaderutils.cpp
    loaderutils.h
    localprofiles.cpp
    localprofiles.h
    moduleinstantiator.cpp
    moduleinstantiator.h
    moduleloader.cpp
    moduleloader.h
    modulepropertymerger.cpp
    modulepropertymerger.h
    moduleproviderloader.cpp
    moduleproviderloader.h
    probesresolver.cpp
    probesresolver.h
    productitemmultiplexer.cpp
    productitemmultiplexer.h
    productresolver.cpp
    productresolver.h
    productscollector.cpp
    productscollector.h
    productsresolver.cpp
    productsresolver.h
    projectresolver.cpp
    projectresolver.h
    )
list_transform_prepend(LOADER_SOURCES loader/)

set(LOGGING_SOURCES
    categories.cpp
    categories.h
    ilogsink.cpp
    logger.cpp
    logger.h
    translator.h
    )
list_transform_prepend(LOGGING_SOURCES logging/)

set(LOGGING_HEADERS logging/ilogsink.h)

set(PARSER_SOURCES
    qmlerror.cpp
    qmlerror.h
    qmljsast.cpp
    qmljsast_p.h
    qmljsastfwd_p.h
    qmljsastvisitor.cpp
    qmljsastvisitor_p.h
    qmljsengine_p.cpp
    qmljsengine_p.h
    qmljsglobal_p.h
    qmljsgrammar.cpp
    qmljsgrammar_p.h
    qmljskeywords_p.h
    qmljslexer.cpp
    qmljslexer_p.h
    qmljsmemorypool_p.h
    qmljsparser.cpp
    qmljsparser_p.h
    )
list_transform_prepend(PARSER_SOURCES parser/)

set(TOOLS_SOURCES
    architectures.cpp
    buildgraphlocker.cpp
    buildgraphlocker.h
    buildoptions.cpp
    clangclinfo.cpp
    clangclinfo.h
    cleanoptions.cpp
    codelocation.cpp
    commandechomode.cpp
    deprecationwarningmode.cpp
    dynamictypecheck.h
    error.cpp
    executablefinder.cpp
    executablefinder.h
    fileinfo.cpp
    fileinfo.h
    filesaver.cpp
    filesaver.h
    filetime.cpp
    filetime.h
    generateoptions.cpp
    hostosinfo.h
    id.cpp
    id.h
    iosutils.h
    joblimits.cpp
    jsliterals.cpp
    jsliterals.h
    jsonhelper.h
    installoptions.cpp
    launcherinterface.cpp
    launcherinterface.h
    launcherpackets.cpp
    launcherpackets.h
    launchersocket.cpp
    launchersocket.h
    msvcinfo.cpp
    msvcinfo.h
    pathutils.h
    pimpl.h
    persistence.cpp
    persistence.h
    porting.h
    preferences.cpp
    processresult.cpp
    processresult_p.h
    processutils.cpp
    processutils.h
    profile.cpp
    profiling.cpp
    profiling.h
    progressobserver.cpp
    progressobserver.h
    projectgeneratormanager.cpp
    propagate_const.h
    qbsassert.cpp
    qbsassert.h
    qbspluginmanager.cpp
    qbspluginmanager.h
    qbsprocess.cpp
    qbsprocess.h
    qttools.cpp
    qttools.h
    scannerpluginmanager.cpp
    scannerpluginmanager.h
    scripttools.cpp
    scripttools.h
    set.h
    settings.cpp
    settingscreator.cpp
    settingscreator.h
    settingsmodel.cpp
    settingsrepresentation.cpp
    setupprojectparameters.cpp
    shellutils.cpp
    shellutils.h
    stlutils.h
    stringconstants.h
    stringutils.h
    toolchains.cpp
    version.cpp
    visualstudioversioninfo.cpp
    visualstudioversioninfo.h
    vsenvironmentdetector.cpp
    vsenvironmentdetector.h
    weakpointer.h
    )
list_transform_prepend(TOOLS_SOURCES tools/)

set(TOOLS_HEADERS
    architectures.h
    buildoptions.h
    cleanoptions.h
    codelocation.h
    commandechomode.h
    deprecationwarningmode.h
    error.h
    generateoptions.h
    installoptions.h
    joblimits.h
    mutexdata.h
    preferences.h
    processresult.h
    profile.h
    projectgeneratormanager.h
    qbs_export.h
    settings.h
    settingsmodel.h
    settingsrepresentation.h
    setupprojectparameters.h
    toolchains.h
    version.h
    )
list_transform_prepend(TOOLS_HEADERS tools/)

set(CPPSCANNER_SOURCES
    Lexer.cpp
    Token.cpp
    cppscanner.cpp
)
list_transform_prepend(CPPSCANNER_SOURCES cppscanner/)

set(CPPSCANNER_HEADERS
    Lexer.h
    Token.h
    cppscanner.h
)
list_transform_prepend(CPPSCANNER_HEADERS cppscanner/)

set(EXTERNAL_DEPENDS "")
if(APPLE)
    set(TOOLS_MACOS_SOURCES
        applecodesignutils.cpp
        applecodesignutils.h
        fileinfo.mm
        )
    list_transform_prepend(TOOLS_MACOS_SOURCES tools/)
    set(EXTERNAL_DEPENDS "-framework Foundation" "-framework Security")
endif()

if(WIN32)
    set(EXTERNAL_DEPENDS "psapi" "shell32")
endif()

add_qbs_library(qbscore
    DEFINES
        "QBS_VERSION=\"${QBS_VERSION}\""
        "QBS_RELATIVE_LIBEXEC_PATH=\"${QBS_RELATIVE_LIBEXEC_PATH}\""
        "QBS_LIBRARY"
        "CPLUSPLUS_NO_PARSER"
        ${QBS_UNIT_TESTS_DEFINES}
    DEPENDS
        Qt${QT_VERSION_MAJOR}::CorePrivate
        Qt${QT_VERSION_MAJOR}::Network
        Qt${QT_VERSION_MAJOR}::Xml
        Qt6Core5Compat
        qbspkgconfig
        qbsquickjs
    PUBLIC_DEPENDS
        Qt${QT_VERSION_MAJOR}::Core
        span
        ${EXTERNAL_DEPENDS}
    INCLUDES
        "${CMAKE_CURRENT_SOURCE_DIR}/../.."
    SOURCES
        ${QBS_HEADERS}
        ${FILE_UPDATE_SOURCES}
        ${API_SOURCES}
        ${API_HEADERS}
        ${BUILD_GRAPH_SOURCES}
        ${BUILD_GRAPH_HEADERS}
        ${GENERATORS_SOURCES}
        ${GENERATORS_HEADERS}
        ${JS_EXTENSIONS_SOURCES}
        ${JS_EXTENSIONS_MACOS_SOURCES}
        ${LANGUAGE_SOURCES}
        ${LANGUAGE_HEADERS}
        ${LOADER_SOURCES}
        ${LOGGING_SOURCES}
        ${LOGGING_HEADERS}
        ${PARSER_SOURCES}
        ${TOOLS_SOURCES}
        ${TOOLS_HEADERS}
        ${CPPSCANNER_SOURCES}
        ${CPPSCANNER_HEADERS}
        ${TOOLS_MACOS_SOURCES}
    )

# not sure if there's a better way to do this
if(INSTALL_PUBLIC_HEADERS)
    install(FILES ${QBS_HEADERS} DESTINATION ${QBS_HEADERS_INSTALL_DIR})
    install(FILES ${API_HEADERS} DESTINATION ${QBS_HEADERS_INSTALL_DIR}/api)
    install(FILES ${BUILD_GRAPH_HEADERS} DESTINATION ${QBS_HEADERS_INSTALL_DIR}/buildgraph)
    install(FILES ${GENERATORS_HEADERS} DESTINATION ${QBS_HEADERS_INSTALL_DIR}/generators)
    install(FILES ${LOGGING_HEADERS} DESTINATION ${QBS_HEADERS_INSTALL_DIR}/logging)
    install(FILES ${LANGUAGE_HEADERS} DESTINATION ${QBS_HEADERS_INSTALL_DIR}/language)
    install(FILES ${TOOLS_HEADERS} DESTINATION ${QBS_HEADERS_INSTALL_DIR}/tools)
endif()

=== src/plugins/generator/CMakeLists.txt ===
add_subdirectory(clangcompilationdb)
add_subdirectory(graphviz)
add_subdirectory(iarew)
add_subdirectory(keiluv)
add_subdirectory(makefilegenerator)
add_subdirectory(visualstudio)

=== src/shared/lsp/CMakeLists.txt ===
add_qbs_library(qtclsp
    STATIC
    DEPENDS Qt${QT_VERSION_MAJOR}::Core Qt6Core5Compat
    SOURCES
      algorithm.h
      basemessage.cpp
      basemessage.h
      callhierarchy.cpp
      callhierarchy.h
      client.cpp
      client.h
      clientcapabilities.cpp
      clientcapabilities.h
      completion.cpp
      completion.h
      diagnostics.cpp
      diagnostics.h
      initializemessages.cpp
      initializemessages.h
      jsonkeys.h
      jsonobject.cpp
      jsonobject.h
      jsonrpcmessages.cpp
      jsonrpcmessages.h
      languagefeatures.cpp
      languagefeatures.h
      languageserverprotocol_global.h
      languageserverprotocoltr.h
      lsptypes.cpp
      lsptypes.h
      lsputils.cpp
      lsputils.h
      messages.cpp
      messages.h
      progresssupport.cpp
      progresssupport.h
      semantictokens.cpp
      semantictokens.h
      servercapabilities.cpp
      servercapabilities.h
      shutdownmessages.cpp
      shutdownmessages.h
      textsynchronization.cpp
      textsynchronization.h
      textutils.cpp
      textutils.h
      workspace.cpp
      workspace.h
  )
target_include_directories(
    qtclsp
    PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/../../lib/corelib
    PUBLIC ${CMAKE_CURRENT_SOURCE_DIR}/..
)
target_compile_definitions(qtclsp
  PUBLIC "LANGUAGESERVERPROTOCOL_STATIC_LIBRARY"
)

=== tests/auto/api/CMakeLists.txt ===
add_qbs_test(api
    DEFINES
        "QBS_RELATIVE_LIBEXEC_PATH=\"${QBS_RELATIVE_LIBEXEC_PATH}\""
        "QBS_RELATIVE_SEARCH_PATH=\"${QBS_RELATIVE_SEARCH_PATH}\""
        "QBS_RELATIVE_PLUGINS_PATH=\"${QBS_RELATIVE_PLUGINS_PATH}\""
    SOURCES
        tst_api.cpp
        tst_api.h
    )

=== src/plugins/generator/iarew/CMakeLists.txt ===
set(COMMON_SOURCES
    iarewfileversionproperty.cpp
    iarewfileversionproperty.h
    iarewgenerator.cpp
    iarewgenerator.h
    iarewgeneratorplugin.cpp
    iarewoptionpropertygroup.cpp
    iarewoptionpropertygroup.h
    iarewproject.cpp
    iarewproject.h
    iarewprojectwriter.cpp
    iarewprojectwriter.h
    iarewsettingspropertygroup.cpp
    iarewsettingspropertygroup.h
    iarewsourcefilepropertygroup.cpp
    iarewsourcefilepropertygroup.h
    iarewsourcefilespropertygroup.cpp
    iarewsourcefilespropertygroup.h
    iarewtoolchainpropertygroup.cpp
    iarewtoolchainpropertygroup.h
    iarewutils.cpp
    iarewutils.h
    iarewversioninfo.h
    iarewworkspace.cpp
    iarewworkspace.h
    iarewworkspacewriter.cpp
    iarewworkspacewriter.h
    )

set(ARCHS_ARM_SOURCES
    armarchiversettingsgroup_v8.cpp
    armarchiversettingsgroup_v8.h
    armassemblersettingsgroup_v8.cpp
    armassemblersettingsgroup_v8.h
    armbuildconfigurationgroup_v8.cpp
    armbuildconfigurationgroup_v8.h
    armcompilersettingsgroup_v8.cpp
    armcompilersettingsgroup_v8.h
    armgeneralsettingsgroup_v8.cpp
    armgeneralsettingsgroup_v8.h
    armlinkersettingsgroup_v8.cpp
    armlinkersettingsgroup_v8.h
    )
list_transform_prepend(ARCHS_ARM_SOURCES archs/arm/)

set(ARCHS_AVR_SOURCES
    avrarchiversettingsgroup_v7.cpp
    avrarchiversettingsgroup_v7.h
    avrassemblersettingsgroup_v7.cpp
    avrassemblersettingsgroup_v7.h
    avrbuildconfigurationgroup_v7.cpp
    avrbuildconfigurationgroup_v7.h
    avrcompilersettingsgroup_v7.cpp
    avrcompilersettingsgroup_v7.h
    avrgeneralsettingsgroup_v7.cpp
    avrgeneralsettingsgroup_v7.h
    avrlinkersettingsgroup_v7.cpp
    avrlinkersettingsgroup_v7.h
    )
list_transform_prepend(ARCHS_AVR_SOURCES archs/avr/)

set(ARCHS_MCS51_SOURCES
    mcs51archiversettingsgroup_v10.cpp
    mcs51archiversettingsgroup_v10.h
    mcs51assemblersettingsgroup_v10.cpp
    mcs51assemblersettingsgroup_v10.h
    mcs51buildconfigurationgroup_v10.cpp
    mcs51buildconfigurationgroup_v10.h
    mcs51compilersettingsgroup_v10.cpp
    mcs51compilersettingsgroup_v10.h
    mcs51generalsettingsgroup_v10.cpp
    mcs51generalsettingsgroup_v10.h
    mcs51linkersettingsgroup_v10.cpp
    mcs51linkersettingsgroup_v10.h
    )
list_transform_prepend(ARCHS_MCS51_SOURCES archs/mcs51/)

set(ARCHS_STM8_SOURCES
    stm8archiversettingsgroup_v3.cpp
    stm8archiversettingsgroup_v3.h
    stm8assemblersettingsgroup_v3.cpp
    stm8assemblersettingsgroup_v3.h
    stm8buildconfigurationgroup_v3.cpp
    stm8buildconfigurationgroup_v3.h
    stm8compilersettingsgroup_v3.cpp
    stm8compilersettingsgroup_v3.h
    stm8generalsettingsgroup_v3.cpp
    stm8generalsettingsgroup_v3.h
    stm8linkersettingsgroup_v3.cpp
    stm8linkersettingsgroup_v3.h
    )
list_transform_prepend(ARCHS_STM8_SOURCES archs/stm8/)

set(ARCHS_MSP430_SOURCES
    msp430archiversettingsgroup_v7.cpp
    msp430archiversettingsgroup_v7.h
    msp430assemblersettingsgroup_v7.cpp
    msp430assemblersettingsgroup_v7.h
    msp430buildconfigurationgroup_v7.cpp
    msp430buildconfigurationgroup_v7.h
    msp430compilersettingsgroup_v7.cpp
    msp430compilersettingsgroup_v7.h
    msp430generalsettingsgroup_v7.cpp
    msp430generalsettingsgroup_v7.h
    msp430linkersettingsgroup_v7.cpp
    msp430linkersettingsgroup_v7.h
    )
list_transform_prepend(ARCHS_MSP430_SOURCES archs/msp430/)

add_qbs_plugin(iarewgenerator
    DEPENDS qbscore
    SOURCES
        ${COMMON_SOURCES}
        ${ARCHS_ARM_SOURCES}
        ${ARCHS_AVR_SOURCES}
        ${ARCHS_MCS51_SOURCES}
        ${ARCHS_STM8_SOURCES}
        ${ARCHS_MSP430_SOURCES}
    )

=== src/plugins/generator/visualstudio/CMakeLists.txt ===
set(SOURCES
    msbuildfiltersproject.cpp
    msbuildfiltersproject.h
    msbuildqbsgenerateproject.cpp
    msbuildqbsgenerateproject.h
    msbuildqbsproductproject.cpp
    msbuildqbsproductproject.h
    msbuildsharedsolutionpropertiesproject.cpp
    msbuildsharedsolutionpropertiesproject.h
    msbuildsolutionpropertiesproject.cpp
    msbuildsolutionpropertiesproject.h
    msbuildtargetproject.cpp
    msbuildtargetproject.h
    msbuildutils.h
    visualstudiogenerator.cpp
    visualstudiogenerator.h
    visualstudioguidpool.cpp
    visualstudioguidpool.h
    visualstudiogeneratorplugin.cpp
    )

add_qbs_plugin(visualstudiogenerator
    DEPENDS qbscore qbsmsbuild
    SOURCES ${SOURCES}
    )

=== debian/changelog ===
qbs (3.1.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Update the patches:
    - gcc-handle-absolute-module-source-paths-in-modules.json.diff: drop, fixed
      upstream
  * upstream-test-suite autopkgtest: use the value returned by "nproc" as number
    of jobs for the build of the blackbox tests; this should speed up the test
    a bit.

 -- Pino Toscano <pino@debian.org>  Thu, 30 Oct 2025 20:26:58 +0100

=== debian/control ===
Source: qbs
Section: devel
Priority: optional
Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Dmitry Shachnev <mitya57@debian.org>,
Build-Depends: cmake,
               debhelper-compat (= 13),
               dpkg-build-api (= 1),
               pkg-kde-tools,
               qt6-5compat-dev,
               qt6-base-dev (>= 6.4.2+dfsg-12~),
               qt6-base-private-dev,
Build-Depends-Arch: 7zip <!nocheck>,
                    bison <!nocheck>,
                    flex <!nocheck>,
                    icoutils <!nocheck>,
                    qt6-declarative-dev <!nocheck>,
                    qt6-scxml-dev <!nocheck>,
                    qt6-shadertools-dev <!nocheck>,
                    qt6-tools-dev <!nocheck>,
                    unzip <!nocheck>,
                    zip <!nocheck>,
Build-Depends-Indep: python3-bs4,
                     python3-lxml,
                     qt6-tools-dev,
Standards-Version: 4.7.2
Homepage: https://wiki.qt.io/Qbs
Vcs-Git: https://salsa.debian.org/qt-kde-team/qt/qbs.git
Vcs-Browser: https://salsa.debian.org/qt-kde-team/qt/qbs/

Package: qbs
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: qbs-common (= ${source:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: cross-platform build tool
 Qbs is a general purpose cross-platform build tool that aims at fast and
 correct incremental builds. It features a project description language that
 is similar to QML.

Package: qbs-common
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Qbs static files
 Qbs is a general purpose cross-platform build tool that aims at fast and
 correct incremental builds. It features a project description language that
 is similar to QML.
 .
 This package contains Qbs shared static files.

Package: libqbscore3.1
Architecture: any
Multi-Arch: same
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: qbs-common (= ${source:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: Qbs core library
 Qbs is a general purpose cross-platform build tool that aims at fast and
 correct incremental builds. It features a project description language that
 is similar to QML.
 .
 This package contains Qbs core shared library.

Package: qbs-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libqbscore3.1 (= ${binary:Version}), ${misc:Depends}
Description: Qbs development files
 Qbs is a general purpose cross-platform build tool that aims at fast and
 correct incremental builds. It features a project description language that
 is similar to QML.
 .
 This package contains headers and development files for Qbs.

Package: qbs-examples
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Description: examples for Qbs build tool
 Qbs is a general purpose cross-platform build tool that aims at fast and
 correct incremental builds. It features a project description language that
 is similar to QML.
 .
 This package contains the example source projects for Qbs.

Package: qbs-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Description: Qbs documentation
 Qbs is a general purpose cross-platform build tool that aims at fast and
 correct incremental builds. It features a project description language that
 is similar to QML.
 .
 This package contains the documentation for Qbs in QCH format, which can be
 viewed using Qt Assistant from assistant-qt6 package.

Package: qbs-doc-html
Multi-Arch: foreign
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: Qbs HTML documentation
 Qbs is a general purpose cross-platform build tool that aims at fast and
 correct incremental builds. It features a project description language that
 is similar to QML.
 .
 This package contains the HTML documentation for Qbs.

=== debian/tests/control ===
Tests: upstream-test-suite
Depends: @builddeps@, build-essential, qbs
Restrictions: allow-stderr

=== debian/watch ===
version=4
https://download.qt.io/official_releases/qbs/([\d\.]*)/qbs-src-([^-]*)\.tar\.gz

## qbs 3.1.2

=== debian/changelog ===
qbs (3.1.2-2) unstable; urgency=medium

  * Team upload.
  * Define PATH_MAX if not available, to help building on GNU/Hurd;
    patch path_max.diff.
  * Increase the timeout of qtest with QTEST_FUNCTION_TIMEOUT also for alpha,
    and hppa.
  * Backport upstream commit a8a17646b136873132c5fba98ee1bea681a7dcaa to build
    with Qt 6.10; patch upstream_Fix-build-with-Qt-6.10.patch.
  * Fix copyright. (Closes: #1127583)
  * Bump Standards-Version to 4.7.3, no changes required.
  * Drop Priority: optional, no more needed since dpkg 1.22.13.

 -- Pino Toscano <pino@debian.org>  Sat, 14 Feb 2026 09:44:14 +0100

qbs (3.1.2-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.

 -- Pino Toscano <pino@debian.org>  Fri, 12 Dec 2025 08:37:27 +0100

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: qbs
 Section: devel
-Priority: optional
 Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
 Uploaders: Dmitry Shachnev <mitya57@debian.org>,
 Build-Depends: cmake,
@@ -23,7 +22,7 @@
 Build-Depends-Indep: python3-bs4,
                      python3-lxml,
                      qt6-tools-dev,
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Homepage: https://wiki.qt.io/Qbs
 Vcs-Git: https://salsa.debian.org/qt-kde-team/qt/qbs.git
 Vcs-Browser: https://salsa.debian.org/qt-kde-team/qt/qbs/

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

include /usr/share/dpkg/default.mk

ifneq ($(filter $(DEB_HOST_ARCH),alpha hppa riscv64),)
export QTEST_FUNCTION_TIMEOUT=900000
endif

ifeq ($(call dpkg_vendor_derives_from,ubuntu),yes)
ifneq ($(filter $(DEB_HOST_ARCH),ppc64el amd64),)
export DEB_CXXFLAGS_MAINT_STRIP=-O3
export DEB_CXXFLAGS_MAINT_APPEND=-O2
endif
endif

BUILDPATH ?= obj-$(DEB_HOST_GNU_TYPE)

%:
	dh $@ --with pkgkde_symbolshelper --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- \
		-DQBS_ENABLE_RPATH=no \
		-DWITH_TESTS=yes \
		-DWITH_UNIT_TESTS=yes \
		-DQBS_LIB_INSTALL_DIR=lib/${DEB_HOST_MULTIARCH} \
		-DQBS_PLUGINS_INSTALL_BASE=lib/${DEB_HOST_MULTIARCH} \
		-DQBS_INSTALL_MAN_PAGE=yes \
		-DQBS_INSTALL_HTML_DOCS=$(if $(filter qbs-doc-html, $(shell dh_listpackages)),yes,no) \
		-DQBS_INSTALL_QCH_DOCS=$(if $(filter qbs-doc, $(shell dh_listpackages)),yes,no)

override_dh_auto_build-arch:
	dh_auto_build -- -C src
ifeq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	dh_auto_build -- -C share
	dh_auto_build -- -C tests
endif

override_dh_auto_install-arch:
	dh_auto_install -- -C src
	dh_auto_install -- -C doc/man

override_dh_auto_build-indep:
	dh_auto_build --no-parallel -- -C doc
	dh_auto_build -- -C share

override_dh_auto_install-indep:
	dh_auto_install --no-parallel -- -C doc
	dh_auto_install -- -C share

override_dh_auto_test-arch:
ifeq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	set -ex; \
		export LD_LIBRARY_PATH=$(BUILDPATH)/lib/${DEB_HOST_MULTIARCH}:$$LD_LIBRARY_PATH; \
		export HOME=$(CURDIR)/debian/.debhelper/generated/_source/home; \
		export QBS_AUTOTEST_PROFILE=qbs_autotests; \
		export QBS_AUTOTEST_ALWAYS_LOG_STDOUT=1; \
		export QBS_AUTOTEST_ALWAYS_LOG_STDERR=1; \
		$(BUILDPATH)/bin/qbs-setup-toolchains /usr/bin/gcc gcc; \
		$(BUILDPATH)/bin/qbs-setup-qt /usr/bin/qmake6 qbs_autotests; \
		[ -n "`$(BUILDPATH)/bin/qbs-config --list profiles.qbs_autotests.baseProfile`" ] || \
			$(BUILDPATH)/bin/qbs-config profiles.qbs_autotests.baseProfile gcc; \
		LC_ALL=C.UTF-8 dh_auto_test --max-parallel=1
endif

override_dh_auto_test-indep:

override_dh_compress:
	dh_compress --exclude=.qch
